/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package serveurAdministration;

import exception.LocationException;
import exception.RequeteException;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.Socket;
import java.net.SocketException;
import java.util.logging.Level;
import java.util.logging.Logger;
import serveurClient.EsclaveClient;
import serveurlocation.FinClientException;
import serveurlocation.FinServeurException;

/**
 *
 * @author cf
 */
class EsclaveAdministration implements Runnable {
    private final Socket socket;
    private final ServeurAdministration serveur;
    
    EsclaveAdministration(Socket socket, ServeurAdministration serveur) {
        this.socket = socket;
        this.serveur = serveur;
    }

    @Override
    public void run() {
        BufferedReader input = null;
        Writer output = null;
        try { 
            input = new BufferedReader(
                new InputStreamReader(socket.getInputStream(),
                            "8859_1"),1024); // flux en lecture
            output = new OutputStreamWriter(
                socket.getOutputStream(), "8859_1"); // flux en écriture
        
            RequeteGestionAdministration requeteGestion = new RequeteGestionAdministration();
            
            while(true) {
                try {
                    StringBuffer sb = new StringBuffer("");
                    sb.append(input.readLine());
                    String[] commande = sb.toString().split(" ");
                    output.write(sb + " : " + requeteGestion.manage(commande)); // gestion définie ailleurs
                    output.flush();
                }
                catch (LocationException e) {
                    try {
                    output.write(e.getMessage() + "\n");
                    output.flush();
                    } catch (IOException ex) {return;}
                }
                catch (RequeteException e) {
                    try {
                    output.write(e.getMessage() + "\n");
                    output.flush();
                    } catch (IOException ex) {return;}
                }
                catch (FinServeurException e) {serveur.setIsFinished(true); return;}
                catch (FinClientException e) {System.out.println(e); return;}
                catch (SocketException e) {return;}
            }
        }
        catch (IOException e) {
            try {
                output.write("Erreur de traitement de la requête\n");
            } catch (IOException ex) {
                Logger.getLogger(EsclaveClient.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}
